--- dial_box.c	2001-10-22 14:22:06.000000000 -0400
+++ dial_box.c	2014-12-27 05:04:35.000000000 -0500
@@ -246,17 +246,15 @@ int ExposeDialogBox ( ev )
 **	Ouput :
 */
-char *GetStringFromDB ( prompt, one_char  )
-    char *prompt;
+const char *GetStringFromDB ( prompt, one_char  )
+    const char *prompt;
     int one_char;
 {
-    char *s;
+    const char *s;
     
     if ( one_char == True )
       display_ok = False;
 
-    if ( strlen (prompt) > 64 )
-      prompt [64] = '\0';
     (void) DisplayDialogBox ();
-    s = (char *) InputString ( dial_box.w_mb, dial_box.frame,
+    s = InputString ( dial_box.w_mb, dial_box.frame,
 	      dial_box.gc, dial_box.font, prompt , one_char );
     (void) UnmapDialogBox ();
--- dial_box.h	1997-01-24 09:55:13.000000000 -0500
+++ dial_box.h	2014-12-26 01:48:58.000000000 -0500
@@ -69,8 +69,8 @@ typedef struct _DBox {
 #define GetDialBoxFrame() (dial_box.frame)
 
-FCT (void, InitDialogBox, () );
+FCT (void, InitDialogBox, (void) );
 FCT (void, ConfigDialogBox, (int width, int height) );
 FCT (int, ExposeDialogBox, (XEvent *ev) );
-FCT (char *, GetStringFromDB, (char *prompt, int one_char) );
+FCT (const char *, GetStringFromDB, (const char *prompt, int one_char) );
 FCT (int, ButtonDialogBox, (XButtonEvent *ev) );
 
--- file_dict.c	2002-11-24 14:03:50.000000000 -0500
+++ file_dict.c	2014-12-27 03:31:18.000000000 -0500
@@ -45,4 +45,5 @@
 #endif
 #include <stdio.h>
+#include <stdlib.h>
 
 #include "result_types.h"
@@ -65,5 +66,5 @@ char 	 Mark = 0;
 */
 FileRec* create_file (file_name)
-    char* file_name;
+    const char* file_name;
 {
   FileRec**  head;
@@ -88,5 +89,5 @@ FileRec* create_file (file_name)
 */
 FileRec* find_file(file_name)
-    char* file_name;
+    const char* file_name;
 {
   FileRec**  head;
@@ -102,5 +103,5 @@ FileRec* find_file(file_name)
 */
 void remove_file(file_name)
-    char* file_name;
+    const char* file_name;
 {
   FileRec **  head;
@@ -127,5 +128,5 @@ void remove_file(file_name)
 */
 void mark_remove_file(file_name)
-    char* file_name;
+    const char* file_name;
 {
   FileRec**  head;
--- file_dict.h	2002-11-24 09:40:51.000000000 -0500
+++ file_dict.h	2014-12-27 03:30:16.000000000 -0500
@@ -72,13 +72,13 @@ extern  int      file_count;
 */
 
-extern FileRec* create_file   (/* char* file_name */);
+extern FileRec* create_file   (const char* file_name);
 
-extern FileRec* find_file     (/* char* file_name */);
+extern FileRec* find_file     (const char* file_name);
 
-extern void     remove_file   (/* char* file_name */);
+extern void     remove_file   (const char* file_name);
 
-extern void 	mark_remove_file(/* char* file_name */);
+extern void 	mark_remove_file(const char* file_name);
 
-extern void     remove_marked_files();
+extern void     remove_marked_files(void);
 
 #endif  /*  FILEDICT_H  */
--- fs_box.c	2006-11-16 03:51:03.000000000 -0500
+++ fs_box.c	2014-12-27 15:01:32.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <unistd.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -90,4 +91,7 @@
 #include "list_box.h"
 #include "warn_box.h"
+#include "text_cursor.h"
+#include "chars_cmds.h"
+#include "Smac/smac.h"
 
 #define S_DELAY 15000
@@ -96,15 +100,14 @@ extern Display *dpy;
 FBox fs_box;
 static  Atom fs_del;
-extern char  *getcwd();
 
 FCT (static int, LoadFilesAndDirs, (char * dir) );
 FCT (static void, MapFsBox, () );
 FCT (static int, NewCompare, (char ** s1, char ** s2) );
-FCT (static void, RefreshDirTitle, (char *dirname) );
+FCT (static void, RefreshDirTitle, (const char *dirname) );
 FCT (static void, RefreshDirsAndFiles, () );
 FCT (static void, RefreshFSTitleBox, () );
 FCT (static void, UnmapFsBox, () );
 
-static char *internal_dirname = 0;
+static char *internal_dirname = NULL;
 
 /*
@@ -292,8 +295,8 @@ static void UnmapFsBox ()
 **	Ouput :
 */
-char *SelectFileFromBox ( msg )
-    char *msg;
+const char *SelectFileFromBox ( msg )
+    const char *msg;
 {
-    char *s = 0;
+    const char *s = NULL;
     static char full_path_select [MAXPATHLEN];
 
@@ -302,5 +305,5 @@ char *SelectFileFromBox ( msg )
 	if ( strlen ( msg ) > (TITLE_SIZE - 2) ) {
 	    (void) strncpy ( fs_box.title_text, msg, TITLE_SIZE -1 );
-	    fs_box.title_text [TITLE_SIZE] = '\0';
+	    fs_box.title_text [TITLE_SIZE-1] = '\0';
 	}
 	else
@@ -318,5 +321,5 @@ char *SelectFileFromBox ( msg )
       XMapRaised ( dpy, fs_box.frame );
     
-    s = (char *) InputString ( fs_box.mb_frame, fs_box.frame, 
+    s = InputString ( fs_box.mb_frame, fs_box.frame, 
 			      fs_box.gc, fs_box.font, "File name : " , 0 );
     if ( (s != 0) && (*s == '~') )
@@ -324,5 +327,5 @@ char *SelectFileFromBox ( msg )
     (void) UnmapFsBox ();
 
-    if ( (s != 0) && (*s != '\007') && (*s != '/') ) {
+    if ( (s != NULL) && (*s != '\007') && (*s != '/') ) {
 	if ( (*s == '.') && (strlen(s) == 1) )
 	  (void) sprintf ( full_path_select, "%s", fs_box.dirname );
@@ -757,5 +760,5 @@ int ButtonFsBox ( ev )
 **	Output :
 */
-char *GetFsBoxInternalDir()
+const char *GetFsBoxInternalDir()
 {
     return (internal_dirname);
@@ -771,13 +774,13 @@ char *GetFsBoxInternalDir()
 */
 static void RefreshDirTitle ( dirname )
-    char *dirname;
+    const char *dirname;
 {
   int start, width;
-  char *old = dirname;
+  const char *old = dirname;
   
-  if(dirname) {
+  if (dirname) {
       if (internal_dirname)
 	free(internal_dirname);
-      internal_dirname = (char *) malloc(strlen(dirname) + 3);
+      internal_dirname = malloc(strlen(dirname) + 3);
       strcpy(internal_dirname, dirname);
 	if ( *internal_dirname == '/'  && strlen(internal_dirname) != 1) { /*pas la racine */
--- fs_box.h	2001-06-17 06:51:14.000000000 -0400
+++ fs_box.h	2014-12-26 01:19:07.000000000 -0500
@@ -89,7 +89,7 @@ FCT (int, ButtonFsBox, ( XButtonEvent * 
 FCT (void, ConfigFsBox, (int width, int height) );
 FCT (int, ExposeFsBox, (XEvent *ev) );
-FCT (void, InitFsBox, () );
-FCT (char *, GetFsBoxInternalDir, () );
-FCT (char *, SelectFileFromBox, (char *msg) );
+FCT (void, InitFsBox, (void) );
+FCT (const char *, GetFsBoxInternalDir, (void) );
+FCT (const char *, SelectFileFromBox, (const char *msg) );
 
 #endif /* _FS_BOX_H_ */
--- get_file.c	2000-04-12 15:37:22.000000000 -0400
+++ get_file.c	2014-12-27 23:35:37.000000000 -0500
@@ -85,9 +85,10 @@
 #include "ie_func.h"
 #include "selection.h"
+#include "BR_Global.h"
+#include "Smac/smac.h"
+#include "Smac/smacXcoral.h"
 
-FCT (static int, CheckFile, (char *path, int *len, Text *text) );
-FCT (static int, IsBinary, (FILE *fd, Text *text, int len) );
+FCT (static int, CheckFile, (const char *path, int *len, const Text *text) );
 FCT (static void, KillCurrentBuffer, (Text *text, int from) );
-FCT (static char*, MyStrerror,  ( int err ) );
 
 extern 	Display	*dpy;
@@ -106,5 +107,5 @@ void KbdReadFile ( text )
     Text *text;
 {
-    char *str, *color; 
+    const char *str; 
     Text *result;
     char c = '\007'; /* ^G */
@@ -161,5 +162,5 @@ void KbdInsertFile ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     char c = '\007'; /* ^G */
     int nbl, olen;
@@ -170,10 +171,10 @@ void KbdInsertFile ( text )
     str = GetString ( text, "Insert File : ", 0 );
     
-    if ( (str == 0) || (strncmp(str, &c, 1)) == 0 ) {
+    if ((str == NULL) || (strncmp(str, &c, 1)) == 0 ) {
 	DisplayMessage ( text -> mwin, "Abort" );
 	return;
     }
     if ( *str == '~' )
-      str = ExpandTildeName ( str );
+      str = ExpandTildeName (str);
     
     if (text -> selection -> select == True) {
@@ -228,5 +229,5 @@ void KbdInsertFile ( text )
 int LoadFile ( text, s, type )
     Text *text;
-    char *s;
+    const char *s;
     int type;
 {
@@ -235,5 +236,5 @@ int LoadFile ( text, s, type )
     Mode *mode;
     FILE *fd;
-    extern flag_visit;
+    extern int flag_visit;
     
 #ifdef DEBUG
@@ -246,8 +247,4 @@ int LoadFile ( text, s, type )
 	    return -1;
 	}
-	if ( IsBinary ( fd, text, len ) == True ) {
-	    (void) fclose ( fd );
-	    return -1;
-	}
 	rewind ( fd );
 	switch ( type ) {
@@ -300,11 +297,10 @@ int LoadFile ( text, s, type )
 void SetDirAndFilename ( text, name )
     Text *text;
-    char *name;
+    const char *name;
 {
     char *p;
     char *old_dir;
     char pathname [ MAXPATHLEN + 2];
-    extern char  *getcwd();
-    
+ 
     /*
      * Ici, name est un pathname valide. On doit utiliser le pathname
@@ -389,5 +385,5 @@ void KbdSaveFile ( text )
     Text *text;
 {
-    char   *name;
+    const char *name;
     char c = '\007';
     
@@ -498,5 +494,5 @@ void KbdWriteFile ( text )
     Text *text;
 {
-    char *s;
+    const char *s;
     char buf [256];
     char c = '\007';
@@ -521,8 +517,8 @@ void KbdWriteFile ( text )
     s = GetString ( text, buf, 0 );
 
-    if ( (s == 0) || ((strncmp(s,"y",1) == 0) &&(strlen(s)==1)) ) {
+    if (s == NULL || (s[0] == 'y' && s[1] == '\0')) {
 	WriteFile ( text );
     }
-    else if ( ((strncmp(s,"n",1 ) == 0)&&(strlen(s)==1)) || (strncmp(s,&c,1)==0) ) {
+    else if ((s[0] == 'n' && s[1] == '\0') || s[0] == c) {
 	DisplayMessage ( text -> mwin, "Abort" );
     }
@@ -556,7 +552,7 @@ void KbdWriteFile ( text )
 */
 static int CheckFile ( path, len, text )
-    char *path;
+    const char *path;
     int *len;	/* RETURN */
-    Text *text;
+    const Text *text;
 {
     struct stat st;
@@ -584,21 +580,4 @@ static int CheckFile ( path, len, text )
 
 /*
-**	Function name : IsBinary
-**
-**	Description : On verifie que le fichier n'est pas
-**		un binaire ou une archive.
-**	Input : Le stream associe, le text courant, la longueur du fichier.
-**	Ouput : Vrai si binaire Faux sinon.
-*/
-static int IsBinary ( fd, text, len )
-    FILE *fd;
-    Text *text;
-    int len;
-{
-  return False;
-}
-
-
-/*
 **	Function name : MenuReadFile
 **
@@ -610,6 +589,5 @@ void MenuReadFile ( text )
     Text *text;
 {
-    char *str = 0;
-    char *color;
+    const char *str;
     Text *result;
     char c = '\007'; /* ^G */
@@ -621,5 +599,5 @@ void MenuReadFile ( text )
     ClearMessageWindow ( text -> mwin );
 
-    str = (char *) SelectFileFromBox ( "Read File" );
+    str = SelectFileFromBox ("Read File");
     
     if ( (str == 0) || (strncmp(str, &c, 1)) == 0 ) {
@@ -726,5 +704,5 @@ void MenuSaveFile ( text )
     Text *text;
 {
-    char   *name;
+    const char *name;
     char c = '\007';
     
@@ -735,7 +713,7 @@ void MenuSaveFile ( text )
 
     if ( strcmp (text -> filename, "NoName") == 0 ) {
-	name = (char *) GetStringFromDB ( "Write file : ", False );
+	name = GetStringFromDB ("Write file : ", False);
 	
-	if ( (name == 0) || strncmp(name, &c,1) == 0 ) {
+	if (name == NULL || name[0] == c) {
 	    DisplayMessage ( text -> mwin, "Abort" );
 	    return;
@@ -782,5 +760,5 @@ void MenuWriteFile ( text )
     Text *text;
 {
-    char *s;
+    const char *s;
     char buf [256];
     char c = '\007';
@@ -1018,6 +996,6 @@ void LoadAndEvalFile ( text )
     Text *text;
 {
-    char *msg = 0;
-    char *s = 0;
+    const char *msg = NULL;
+    const char *s;
     char c = '\007';
 
@@ -1038,6 +1016,6 @@ void LoadAndEvalFile ( text )
       if ( *s == '~' )
 	s = ExpandTildeName ( s );
-	
-      msg = (char * ) ie_load_file ( text, s );
+
+      msg = ie_load_file ( text, s );
       update_cwd(nw);
     }
@@ -1090,7 +1068,4 @@ Text * update_cwd(win_id)
 }
 
-FCT (extern int, browser_dump,(char *));
-FCT (extern int, browser_restore,(char *));
-
 void MenuBrowserDump ( text )
     Text *text;
@@ -1129,5 +1104,5 @@ void MenuBrowserRestore ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     
     if (text) {
@@ -1139,7 +1114,7 @@ void MenuBrowserRestore ( text )
     }
 
-    str = (char *) SelectFileFromBox ( "Browser restore file" );
+    str = SelectFileFromBox ( "Browser restore file" );
     
-    if ((str == 0) || (*str == 7)) {
+    if (str == NULL || *str == 7) {
 	if (text)
 	  DisplayMessage ( text -> mwin, "Abort" );
@@ -1162,5 +1137,5 @@ void KbdBrowserDump ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     
     ClearMessageWindow ( text -> mwin );
@@ -1168,5 +1143,5 @@ void KbdBrowserDump ( text )
     str = GetString ( text, "Browser dump File : ", 0 );
     
-    if ((str == 0) || (*str == 7)) {
+    if (str == NULL || *str == 7) {
 	DisplayMessage ( text -> mwin, "Abort" );
 	return;
@@ -1187,5 +1162,5 @@ void KbdBrowserRestore ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     
     ClearMessageWindow ( text -> mwin );
@@ -1193,5 +1168,5 @@ void KbdBrowserRestore ( text )
     str = GetString ( text, "Restore File : ", 0 );
     
-    if ((str == 0) || (*str == 7)) {
+    if (str == NULL || *str == 7) {
 	DisplayMessage ( text -> mwin, "Abort" );
 	return;
@@ -1207,34 +1182,3 @@ void KbdBrowserRestore ( text )
     }
     TextCursorOn ( text );
-}
-
-
-/*---------------------------------------------------------------------
-*/
-static char*
-MyStrerror ( err )
-    int err;
-{
-#if HAVE_STRERROR
-   return strerror ( err );
-#elif HAVE_SYSERR || HAVE_STDIO_SYSERR
-#  if !HAVE_STDIO_SYSERR
-   extern char *sys_errlist[];
-   extern int sys_nerr;
-#  endif
-   static char buffer[32];
-   if (!err)
-     return "";
- 
-   if ((err > 0) && (err < sys_nerr))
-     return (char*) sys_errlist[err];
- 
-   sprintf (buffer, "Unknown error : %d", err);
-   return buffer;
-#else
-#if HAVE_PERROR
-   perror("System error in xcoral excution");
-#endif
-   return("<<< Error message unavailble >>>");
-#endif
-}
+}
\ No newline at end of file
--- get_file.h	1997-03-18 07:14:34.000000000 -0500
+++ get_file.h	2014-12-27 23:35:34.000000000 -0500
@@ -50,5 +50,5 @@ FCT (void, KbdWriteFile, (Text *text) );
 FCT (void, KillBuffer, (Text *text) );
 FCT (void, LoadAndEvalFile, (Text *text) );
-FCT (int, LoadFile, (Text *text, char *s, int type) );
+FCT (int, LoadFile, (Text *text, const char *s, int type) );
 FCT (void, MenuGotoLine, (Text *text) );
 FCT (void, MenuInsertFile, (Text *text) );
@@ -58,5 +58,5 @@ FCT (void, MenuSaveFile, (Text *text) );
 FCT (void, MenuWriteFile, (Text *text) );
 FCT (int, SaveCurrentBuffer, (Text *text, int from) );
-FCT (void, SetDirAndFilename, (Text *text, char *name) );
+FCT (void, SetDirAndFilename, (Text *text, const char *name) );
 FCT (void, WriteFile, (Text *text) );
 FCT (void, SetWindowName, (Text *text) );
--- global_dict.c	2002-11-24 14:03:30.000000000 -0500
+++ global_dict.c	2014-12-27 03:29:02.000000000 -0500
@@ -45,4 +45,5 @@
 #endif
 #include <stdio.h>
+#include <stdlib.h>
 
 #include "result_types.h"
@@ -66,7 +67,7 @@ int global_count = 0;
 */
 GlobalRec* create_global(global_name, staticp, parsed_file)
-    char* global_name;
+    const char* global_name;
     int staticp;
-    char * parsed_file;
+    const char * parsed_file;
 {
   GlobalRec**  head;
@@ -99,5 +100,5 @@ GlobalRec* create_global(global_name, st
 */
 GlobalRec* find_global(global_name)
-  char* global_name;
+  const char* global_name;
 {
   GlobalRec**  head;
@@ -114,5 +115,5 @@ GlobalRec* find_global(global_name)
 */
 void global_eraze_file(file_name)
-    char * file_name;
+    const char * file_name;
 {
   FileRec * current_file;
--- global_dict.h	2002-11-24 05:32:35.000000000 -0500
+++ global_dict.h	2014-12-27 03:29:26.000000000 -0500
@@ -73,14 +73,11 @@ extern  int global_count;
 */
 
-extern GlobalRec*     create_global   (/* char* global */);
+extern GlobalRec*     create_global   (const char* global, int staticp, const char *filename);
 
-extern GlobalRec*     find_global     (/* char* global */);
+extern GlobalRec*     find_global     (const char* global);
 
-extern void           global_eraze_marked_files();
+extern void           global_eraze_marked_files(void);
+extern void           global_eraze_file(const char *file_name);
 
 
 #endif  /*  GLOBALDICT_H  */
-
-
-
-
--- handle_key.c	2005-12-20 03:58:50.000000000 -0500
+++ handle_key.c	2014-12-26 01:59:52.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <X11/Xlib.h>
 #include <X11/cursorfont.h>
@@ -256,5 +257,5 @@ Trans st_repeat [] = {
 
 int 	repeat_num = 0;	/* Pour les repetitions		*/
-static deletewindow = False;
+static int deletewindow = False;
 
 static KeySym	ksym;
@@ -491,5 +492,5 @@ static void f_ascii ( text, infos )
 	  (func) ( text );
 	  if ( InsideMacro ( text ) == True )
-	    LoadMacro ( text, func, (void *)infos->ch, repeat );
+	    LoadMacro (text, func, (void *)(intptr_t)infos->ch, repeat);
 	}
 	else if ( (type == EXTERN_FUNC) && (func != 0 )) {
@@ -516,5 +517,5 @@ static void f_ascii ( text, infos )
 	  f_impc ( text, (int) infos -> ch );
 	  if ( InsideMacro ( text ) == True )
-	    LoadMacro ( text, (void(*)()) f_impc, (void *) infos -> ch, repeat );
+	    LoadMacro ( text, (void(*)()) f_impc, (void *)(intptr_t)infos -> ch, repeat );
 	  SetTextModif ( text );	
 	}
@@ -558,6 +559,6 @@ static void f_ctrx ( text, infos )
       
       (func) ( text );
-      if ( (InsideMacro ( text ) == True) &&  ((int) func != (int) StartMacro) )
-	LoadMacro ( text, (void(*)()) func, (void *) infos -> ch, repeat );
+      if ( (InsideMacro ( text ) == True) &&  (func != StartMacro) )
+	LoadMacro ( text, (void(*)()) func, (void *)(intptr_t)infos -> ch, repeat );
     }
     else {
@@ -663,5 +664,5 @@ static void f_escape ( text, infos )
     (func) ( text );
     if ( InsideMacro ( text ) == True )
-      LoadMacro ( text, (void(*)()) func, (void *) infos -> ch, repeat );
+      LoadMacro ( text, (void(*)()) func, (void *)(intptr_t)infos -> ch, repeat );
   }	  
   else {
@@ -776,10 +777,10 @@ void GotoLine ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     char c = '\007';
     int n;
     
     TextCursorOff ( text );
-    str = (char *) GetString ( text, "Goto Line : ", 0 );
+    str = GetString ( text, "Goto Line : ", 0 );
     if ( (str == 0) || (strncmp (str, &c, 1 ) == 0) || ((n = atoi ( str )) == 0) )
       DisplayMessage ( text -> mwin, "Abort" );
@@ -843,6 +844,6 @@ void PlayMacro ( text )
 
 static void f_nothing ( text, infos )
-    Text *text;
-    InfosKey *infos;    
+    Text *text __attribute__((unused));
+    InfosKey *infos __attribute__((unused));
 {
 /*    (void) fprintf ( stderr, "Nothing\n" ); */
@@ -850,6 +851,6 @@ static void f_nothing ( text, infos )
 
 static void f_special ( text, infos )
-    Text *text;
-    InfosKey *infos;
+    Text *text __attribute__((unused));
+    InfosKey *infos __attribute__((unused));
 {
 /*    (void) fprintf ( stderr, "Special\n" ); */
@@ -870,5 +871,5 @@ void DisplayLineNumber( text )
     char tmp [64];
     int len, count, nc = GetNcFromLeft(text -> buf);
-    char *cl = GetCurrentLine(text->buf, &len);
+    const char *cl = GetCurrentLine(text->buf, &len);
     int i;
 
@@ -897,10 +898,10 @@ void DisplayLineNumber( text )
 */
 unsigned Xk_Code( name )
-    unsigned char * name;
+    const char * name;
 {
   unsigned i;
   
   for (i = 0; XKInfos[i].name; i += 1)
-    if (! strcasecmp(XKInfos[i].name, (char *) name))
+    if (! strcasecmp(XKInfos[i].name, name))
       /* appelle XK_ksym_to_code pour gerer les ksym egaux */
       return XK_ksym_to_code(XKInfos[i].xk_code);
--- handle_key.h	1997-05-12 09:03:33.000000000 -0400
+++ handle_key.h	2014-12-26 01:35:46.000000000 -0500
@@ -52,5 +52,5 @@ typedef struct _InfosKey {
 
 typedef struct _XKKey{
-  char * name;
+  const char * name;
   KeySym xk_code;
 } XKKey;
@@ -76,5 +76,5 @@ FCT (void, PlayMacro, (Text *text) );
 FCT (ST *, automate, (Text *text, XKeyEvent *event, ST *current_st) );
 
-FCT (unsigned, Xk_Code,(unsigned char *));
+FCT (unsigned, Xk_Code,(const char *));
 FCT (unsigned, XK_ksym_to_code,(KeySym ksym));
 
--- handle_menus.c	2001-02-03 15:10:36.000000000 -0500
+++ handle_menus.c	2014-12-26 01:59:21.000000000 -0500
@@ -39,4 +39,5 @@
 
 #include <stdio.h>
+#include <string.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -45,4 +46,6 @@
 #include "handle_menus.h"
 #include "shadow.h"
+#include "main_text.h"
+#include "main_events.h"
 
 extern XContext	SwContext;
@@ -208,7 +211,6 @@ static void HandleExposeMenu ( display, 
 {
   extern XEvent event;
-  char **str;
+  const char **str;
   int i;
-  XRectangle rec [2];
 #ifdef DEBUG
   ( void ) fprintf ( stderr, "HandleExpose w = %d\n",
@@ -433,6 +435,6 @@ static void show_item ( display, menu, i
 	       DEPTH_DOWN );
   
-  if ( menu -> w_last_item != 0 )
-  if ( menus_color == False ) 
+  if ( menu -> w_last_item != 0 ) {
+    if ( menus_color == False ) 
       XFillRectangle ( display,
 		      menu -> w_last_item,
@@ -442,9 +444,10 @@ static void show_item ( display, menu, i
 		      menu -> vmenu [n] -> width - ( 2 * menu -> width_relief ) - 6,
 		      menu -> h_item - ( 2 * menu -> width_relief ));
-  else
-    Display3D ( display, menu -> w_last_item,
+    else
+      Display3D ( display, menu -> w_last_item,
 	       menu -> top_sh, menu -> bot_sh,
 	       menu -> width_relief,
 	       DEPTH_UP );
+  }
   
   menu -> w_last_item = menu -> vmenu [n] -> w_item [i];
